/* Diccionario generico */

typedef struct dict *Dict;

/* Tabla de operaciones para un diccionario */
typedef struct {
  void (*definir)(Dict d, void *k, void *v);
  int (*vacio)(Dict d);
  void *(*consultar)(Dict d, void *k);
  int (*obtener)(Dict d, void *k, void **pk, void **pv);
  int (*eliminar)(Dict d, void *k);
  void (*destruir)(Dict d);
} DictOps;

/* El nico campo visible de un diccionario es su tabla de operaciones */
struct dict {
  DictOps *ops;
};

typedef int (*Comparador)(void *p, void *q);
