#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <pthread.h>
#include <unistd.h>
#include <string.h>

#include "dict.h"
#include "dict-hash.h"
#include "jsocket.h"
#include "util.h"

typedef void *(*Thread_fun)(void *);

Dict global_dict;

/* Funcion de hashing para strings */

int hash_strings(char *s) {
  int i= 0;
  int h= 0;
  while (*s) {
    h+= *s++ << i++;
    if (i>=24)
      i= 0;
  }
  return h;
}

void *serv(int s) {
  char op;
  char *llave;
 
  printf("cliente conectado\n");
  read(s, &op, 1); /* d, q o r */
  llave= getstr(s);

  if (op=='d') {
    char *val= getstr(s);
    (*global_dict->ops->definir)(global_dict, llave, val);
    sendstr(s, "definicion exitosa");
  }
  else if (op=='q') {
    char *val= global_dict->ops->consultar(global_dict, llave);
    if (val==NULL)
      sendstr(s, "llave no encontrada");
    else
      sendstr(s, val);
    free(llave);
  }
  else if (op=='e') {
    char *llave_orig, *val;
    if (!global_dict->ops->obtener(global_dict, llave,
                 (void**)&llave_orig, (void**)&val))
      sendstr(s, "la eliminacion fallo porque no se encontro la llave");
    else {
      global_dict->ops->eliminar(global_dict, llave);
      sendstr(s, "eliminacion exitosa");
      free(llave_orig);
      free(val);
    }
    free(llave);
  }
  else {
    sendstr(s, "operacion invalida");
    free(llave);
  }
  printf("cliente desconectado\n");
  close(s);
  return NULL;
}

int main(int argc, char **argv) {
  long s, s2;

  global_dict= nuevoDictHash(100, (Comparador)strcmp, (HashFun)hash_strings);
  signal(SIGPIPE, SIG_IGN);
 
  s = j_socket();
 
  if (j_bind(s, 3000) < 0) {
    fprintf(stderr, "bind fallo.  Port 3000 ocupado?\n");
    exit(1);
  }
 
  /* Cada vez que se conecta un cliente le creo un thread */
  for(;;) {
    s2= j_accept(s);
    serv(s2);
  }

  return 0;
}
